function obj = BRANCHE(sys, Uj, Utj, nbtroncons, diaginfos, params)

%% Initialise oblect 'obj' of the BRANCHE class
obj.troncons = cell(nbtroncons,1);

obj.Uj = Uj;

% Does this branch contain stability infos ? Which algo was used ?
obj.stabinfos = params.stability;
obj.stabalgo = params.algostab;

obj = class(obj,'BRANCHE');


%% Compute the portions
Amax = 0;

for i=1:nbtroncons % loop on steps
  normR = norm(get_R(sys,Uj));
  disp([ 'T ' int2str(i) ' : ||R(Uj)|| at begining =' num2str(normR) ]);
  
 % End-step correction is actually done at the begining 
 % of the new step (bug correction, B. Cochelin, 05-2008)
 % EDIT by S.Karkar, 08-2010 : compare to seuil_corr first
 if params.endstepcorron==1
     seuil_corr=get_seuilcorr(sys);
     if normR>seuil_corr
         Uj = correction(sys, get_seuilcorr(sys), get_itemax(sys), Uj);  
    	 disp([ 'After correction ||R(Uj)||=' num2str(norm(get_R(sys,Uj))) ])
         if params.pointdisplay ==1
             if params.stability == 1
                 disp(sys,Uj,get_Ujstab(tron));
             else
                disp(sys,Uj,[1; zeros(diaginfos.nbddl,1)]);
             end
            drawnow;
         end
     end
 end
  
 % Compute current portion 
  tron = TRONCON(sys, Uj, Utj, diaginfos, params, 1);
  [Uj,  Utj, tron] = point_oriente_sortie(tron, get_seuil(sys));  
  [tron, Amax] = evalue_troncon(tron, get_seuil(sys), get_nbptstroncon(sys));

  disp([ 'T ' num2str(i) ' : ||R(Uj)|| at end =' num2str(norm(get_R(sys,Uj)))  '  Amax=' num2str(Amax) ])
  
  obj.troncons{i} = tron;

%  if libere_series == 1
%    tron = libere_serie(tron);
%  end

  % Display customised diagram, if needed
  if params.globaldisplay == 1
    Us = get_Us(tron,get_seuil(sys), get_nbptstroncon(sys));
    if params.stability ==  1
        disp_global(sys, Us, get_Ustab(tron));
    else
        disp_global(sys, Us,[ones(1,size(Uj,2)) ; zeros(diaginfos.nbddl,size(Uj,2))]);
    end
  end
  
  % Udpate main plot
  if ishandle(2); set(0,'CurrentFigure',2); else; figure(2); end; 
  if params.stability == 1
      dispstab(tron);
  else
      disp(tron);
  end
  title('Diagramme');
  if diaginfos.bloquervue == 1
    axis(diaginfos.uaxis);
  else
    axis auto;
  end
  drawnow;
  
  % Display current point (end of current portion)
  if params.pointdisplay ==1
    if params.stability == 1
        disp(sys,Uj,get_Ujstab(tron));
    else
        disp(sys,Uj,[ones(1,size(Uj,2)) ; zeros(diaginfos.nbddl,size(Uj,2))]);
    end
    drawnow;
  end
  
  % Analyse the series, if needed
   if params.analyse_series==1
      analyse_series(tron,Amax,sys);
  end
 
end % end of the loop on steps
