% Correction NR
%                          
% CORRECTION A DIRECTION   
% SUIVANT LE GRADIENT      
%                          

function [U] = correction(sys, seuil, itemax, U )


nbites = 0;

R = get_R(sys,U);
normR = norm(R);


Usave = U;


disp(['N-R : Before correction ||R(Uj)||=' num2str(normR) ] );

while (normR > seuil) && (nbites < itemax)

  nbites = nbites + 1;

  dRdU = get_dRdU(sys,U);
  
  Ut = tangente(sys, dRdU,U);
  
  K = [dRdU ; Ut'];

  U = U - K\[R;0];
  
  R = get_R(sys,U);
  normR = norm(R);      
  
  disp(['N-R' num2str(nbites) ' : ||R(Uj)||=' num2str(normR) ] );
  
end




if isnan(normR)
  warndlg('Correction failed : the computed vector contains NaN values. Going back to last valid point.','Correction phase','on');
  U = Usave;
end


if nbites == itemax
  warndlg('Correction failed : too many iterations. Going back to last valid point.','Correction phase','on');
  U = Usave;
end
