% Returns the number of non-zero elements of the quadratic
% operator contribution to the tangent matrix : dQdU = U^t*Q + U^t*Q^t
% and dQhdU = U^t*Qh+U^t*Qh^t
% for a SYSREGTENS object.

function [nbelem, nbelemh] = get_nbelem(systenseur)

global Q_tens Qh_tens


ninc=size(Q_tens,1);
neq=ninc-1;
neq1=size(Q_tens,2)/ninc;
neqH=neq-neq1;


dQdU = zeros(ninc,neq1);

for i=1:neq1
    Qi_sym=Q_tens(:,ninc*(i-1)+1:ninc*i)+Q_tens(:,ninc*(i-1)+1:ninc*i)';
    dQdU(:,i) = Qi_sym*ones(ninc,1) ;
end

dQhdU = zeros(ninc,neqH);
for i=1:neqH
    Qhi_sym=Qh_tens(:,ninc*(i-1)+1:ninc*i)+Qh_tens(:,ninc*(i-1)+1:ninc*i)';
    dQhdU(:,i) = Qhi_sym*ones(ninc,1) ;
end

% U=rand(ninc,1);
% 
% dQdU2 = reshape((Q_tens'*U)',[],2)';

 nbelem = nnz(dQdU);
 nbelemh= nnz(dQhdU);