% Computes the tangent matrix dRdU for a SYSTENSEUR object

function dRdU = get_dRdU(sys,U)

global L_tens Q_tens


ninc = sys.ninc ;
neq = sys.neq ;

Usp = sparse(U);

%%version 1 et 2
dRdU = sparse([],[],[],ninc,neq,2*nnz(Q_tens)+nnz(L_tens));

%%version 4
% Q_sym = sparse([],[],[],ninc,ninc*neq,2*nnz(Q_tens));

   for i=1:neq
        %%version 1
        %Qi_sym=Q_tens(:,ninc*(i-1)+1:ninc*i)+Q_tens(:,ninc*(i-1)+1:ninc*i)';
        %dRdU(:,i) = Qi_sym*Usp ;
        
        %%version 2
        dRdU(:,i) = Q_tens(:,ninc*(i-1)+1:ninc*i)*Usp+Q_tens(:,ninc*(i-1)+1:ninc*i).'*Usp;
        %%version 4 [très lent]
%         Q_sym(:,ninc*(i-1)+1:ninc*i) = Q_tens(:,ninc*(i-1)+1:ninc*i)+Q_tens(:,ninc*(i-1)+1:ninc*i).';
   end

%%version 1 et 2
dRdU = dRdU' + L_tens;

%%version 3   [doesn't work]
% dQdU= reshape(Usp'*Q_tens,ninc,neq)' ;
% dRdU = L_tens + dQdU + dQdU' ;

%%version 4
% dRdU = reshape(Usp*Q_sym,ninc,neq)' + L_tens ;