
% Utilisation de la variable nbcourbes   dispvars pour le choix du
% nombre de traces de courbes

function [tron, Amax] = evalue_troncon(tron,seuil,nbptstroncon)

A = zeros(nbptstroncon,tron.nbcourbes);
X = zeros(nbptstroncon,tron.nbcourbes);
Y = zeros(nbptstroncon,tron.nbcourbes);

dispvars = tron.dispvars;

Amax=tron.Amax;
coefsX = zeros(tron.ordre+1,1);
coefsY = zeros(tron.ordre+1,1);

for i=1:tron.nbcourbes
  idxX = dispvars(i,1);
  idxY = dispvars(i,2);
  
  % Evaluate series
  for p=0:tron.ordre % coefs are arranged in decreasing 'a' power order
    coefsX(p+1) = tron.Ups(idxX, tron.ordre-p+1);
    coefsY(p+1) = tron.Ups(idxY, tron.ordre-p+1);
  end 
  
  for p=1:nbptstroncon
    
    a = (p-1) / (nbptstroncon-1) * Amax;
    
    A(p,i)= a; 
    
    X(p,i) = polyval(coefsX, a);
    
    Y(p,i) = polyval(coefsY, a);
    
  end
    
end

tron.X = X;
tron.Y = Y;
tron.A = A;
