%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% MANLABINIT v2.0                                   %
% Initialisation of global variables                %
%                           before their use        %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% disable a useless warning that would appear if you haven't closed manlab
% before starting it again
warning off MATLAB:ClassInstanceExists

% standard environment variables
global ML_Uj;
global ML_Ut;
global ML_Ups;
global ML_Ub;
global ML_Ud;
global ML_pointdisplay;
global ML_globaldisplay;
global ML_first_correction_onoff;

% series analysis
global ML_analyse_series;

% stability analysis
global ML_stability;
global ML_algostab;
global ML_stabvars;
global ML_tolstab;
global ML_Ujstab;
global ML_Utstab;
global ML_Ubstab;
global ML_Udstab;

% default values
ML_first_correction_onoff = 1;  % Do a correction step at launch by default
ML_analyse_series =0; % Do not analyse series by default
ML_pointdisplay = 0 ; % Do not display point-related user-defined plots by default
ML_globaldisplay = 0; % Do not display diagram-related user-defined plots by default
ML_stability = 0; % Stability analysis disabled by default
ML_algostab = 2; % If enabled, use Hill's method by default
ML_tolstab = 1e-4; % Default tolerance on Floquets multipliers for stability
