function [check,eigen,vectors] = stabF(sys,ddlstab,HH)

nbptstroncon = length(ddlstab(:,1));

if HH == 0
    nbddlstab = length(ddlstab(1,:));
    nbddl = get_nbddlF(sys, nbddlstab);
    check = zeros(nbptstroncon,1);
    eigen = zeros(nbptstroncon,nbddl);
    vectors = zeros(nbptstroncon,nbddl*nbddl);
    
    for k=1:nbptstroncon
    
        DFX = J0(sys,ddlstab(k,:)) + JL(sys,ddlstab(k,:)) + JQ(sys,ddlstab(k,:),ddlstab(k,:));
        [V,D] = eig(DFX);
        alf = diag(D);
    
        if isempty(find((real(alf) > 0),1))
            stab = 1;
        else
            stab = 0;
        end
    check(k,1) = stab;
    eigen(k,:) = alf';
    vectors(k,:) = reshape(V,nbddl*nbddl,1)';
    end
    
else

    nbddlstab = length(ddlstab(1,1:(end-2))) / (2*HH+1);
    nbddl = get_nbddlF(sys, nbddlstab+1);    
    check = zeros(nbptstroncon,1);
    eigen = zeros(nbptstroncon,nbddl*(2*HH+1));
    vectors = zeros(nbptstroncon,nbddl*nbddl*(2*HH+1));
    XX = reshape(ones(nbddl,1)*(-HH:HH),nbddl*(2*HH+1),1);
%
    for k=1:nbptstroncon
        
        HILL = zeros(nbddl*(2*HH+1));
        II = eye(nbddl);
        JJ = zeros(nbddl*(2*HH+1),nbddl);
        UU = [ddlstab(k,1:nbddlstab) ddlstab(k,end-1)];
        UH = ddlstab(k,nbddlstab+1:end-1);
        omega = ddlstab(k,end);
        
        for h = -HH:HH;
            
            hm = abs(h) - 1;
            hp = abs(h);
            
            for p = h:HH;
                
                pm = abs(p) - 1;
                pp = abs(p);
                    
                if abs(p+h) < (HH+1)
                    
                    if h == 0
                        Ustab = UU;
                    elseif h < 0
                        Ustab = [0.5*UH(nbddlstab*2*hm+1:nbddlstab*(2*hp-1)) UH(end)] + i*0.5*[UH(nbddlstab*(2*hm+1)+1:nbddlstab*2*hp) 0];
                    else
                        Ustab = [0.5*UH(nbddlstab*2*hm+1:nbddlstab*(2*hp-1)) UH(end)] - i*0.5*[UH(nbddlstab*(2*hm+1)+1:nbddlstab*2*hp) 0];
                    end

                    if p == 0
                        Vstab = UU;
                    elseif p < 0
                        Vstab = [0.5*UH(nbddlstab*2*pm+1:nbddlstab*(2*pp-1)) UH(end)] + i*0.5*[UH(nbddlstab*(2*pm+1)+1:nbddlstab*2*pp) 0];
                    else
                        Vstab = [0.5*UH(nbddlstab*2*pm+1:nbddlstab*(2*pp-1)) UH(end)] - i*0.5*[UH(nbddlstab*(2*pm+1)+1:nbddlstab*2*pp) 0];
                    end    
                    
                    ind = p+h + (HH+1);
                    ind0 = ind - 1;
                    opp = -(p+h) + (HH+1);
                    opp0 = opp - 1;
                    
                    if p == h
                        JJ(ind0*nbddl+1:ind*nbddl,1:nbddl) = JJ(ind0*nbddl+1:ind*nbddl,1:nbddl) + JQ(sys,Ustab,Vstab);
                    else
                        JJ(ind0*nbddl+1:ind*nbddl,1:nbddl) = JJ(ind0*nbddl+1:ind*nbddl,1:nbddl) + JQ(sys,Ustab,Vstab);
                        JJ(opp0*nbddl+1:opp*nbddl,1:nbddl) = JJ(opp0*nbddl+1:opp*nbddl,1:nbddl) + JQ(sys,conj(Ustab),conj(Vstab));
                    end    
                end                 
            end
            
            if h < 1
               if h == 0
                   JJ((h+HH)*nbddl+1:(h+HH+1)*nbddl,1:nbddl) = JJ((h+HH)*nbddl+1:(h+HH+1)*nbddl,1:nbddl) + J0(sys,UU) + JL(sys,Ustab);
               else
                   JJ((h+HH)*nbddl+1:(h+HH+1)*nbddl,1:nbddl) = JJ((h+HH)*nbddl+1:(h+HH+1)*nbddl,1:nbddl) + JL(sys,Ustab);
                   JJ((-h+HH)*nbddl+1:(-h+HH+1)*nbddl,1:nbddl) = JJ((-h+HH)*nbddl+1:(-h+HH+1)*nbddl,1:nbddl) + JL(sys,conj(Ustab));
               end
                
            end
            
        end
        
        
        for g = 1:HH
            gm = g - 1;
            go = 2*HH - gm;
            HILL(1:(HH+g)*nbddl,gm*nbddl+1:g*nbddl) = JJ((HH-gm)*nbddl+1:end,:);
            HILL(gm*nbddl+1:g*nbddl,gm*nbddl+1:g*nbddl) = HILL(gm*nbddl+1:g*nbddl,gm*nbddl+1:g*nbddl) + i*omega*II*(HH - gm);
            HILL((HH-gm)*nbddl+1:end,go*nbddl+1:(go+1)*nbddl) = JJ(1:(HH+g)*nbddl,:);
            HILL(go*nbddl+1:(go+1)*nbddl,go*nbddl+1:(go+1)*nbddl) = HILL(go*nbddl+1:(go+1)*nbddl,go*nbddl+1:(go+1)*nbddl) + i*omega*II*(gm - HH);
        end
            
        HILL(:,HH*nbddl+1:(HH+1)*nbddl) = JJ;        
        
        [V,D] = eig(HILL);
        soluce = diag(D);
        med = sum((repmat(XX,1,nbddl*(2*HH+1))).*(abs(V)),1)./sum(abs(V),1);
        [val,ind] = sort(abs(med));

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Ajout tri pour instabilit� 2T        
        test = 0;
        inc = 0;
        inc2T = zeros(1,nbddl);
        for hh = 1:nbddl
            inc = inc +1;
            if abs(abs(imag(soluce(ind(inc)))) - omega/2) < 1e-4
                test = test + 1;
                if test == 1
                    val0 = abs(sign(imag(soluce(ind(inc)))) + sign(real(soluce(ind(inc)))));
                    inc2T(hh) = ind(inc);
                elseif test == 2
                    val1 = abs(sign(imag(soluce(ind(inc:inc+2)))) + sign(real(soluce(ind(inc:inc+2))))) - val0;
                    indint = find(val1==0,1) - 1;
                    inc2T(hh) = ind(inc+indint);
                    inc = inc+2;
                    test = 0;
                end
            else
                inc2T(hh) = ind(inc);
            end
        end
        %
        indorder = [inc2T setdiff(ind,inc2T)];
        alf = soluce(inc2T);
        vecconv = V(:,inc2T);
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%        

%         alf(1:nbddl,1) = soluce(ind(1:nbddl));
%         vecconv(1:(HH*2+1)*nbddl,1:nbddl) = V(:,ind(1:nbddl));
         
        
        if isempty(find((real(alf) > 0),1))
            stab = 1;
        else
            stab = 0;
        end
        
        check(k,1) = stab;
%        eigen(k,:) = soluce(ind)';
        eigen(k,:) = soluce(indorder)';
        vectors(k,:) = reshape(vecconv,(HH*2+1)*nbddl*nbddl,1)';
    end   
end

end

