function [check,eigen] = stabT(sys,ddlstab,HH)

nbptstroncon = length(ddlstab(:,1));

if HH == 0
    nbddlstab = length(ddlstab(1,:));
    nbddl = get_nbddlT(sys, nbddlstab);
    check = zeros(nbptstroncon,1);
    eigen = zeros(nbptstroncon,nbddl);
    
    for i=1:nbptstroncon
    
        DFX = JT(sys,ddlstab(i,:));
        alf = eig(DFX);
    
        if isempty(find((real(alf) > 0),1))
            stab = 1;
        else
            stab = 0;
        end
    check(i,1) = stab;
    eigen(i,:) = alf';
    end
    
else

    backddl = length(ddlstab(1,1:(end-2))) / (2*HH+1);
    nbddl = get_nbddlT(sys, backddl+1);    
    check = zeros(nbptstroncon,1);
    eigen = zeros(nbptstroncon,nbddl);

    for i=1:nbptstroncon
    
        alf = stabTT(sys,ddlstab(i,:),HH);
        
        if isempty(find((abs(alf) > 1),1))
            stab = 1;
        else
            stab = 0;
        end
        
        check(i,1) = stab;
        eigen(i,:) = alf';
    end   
end

end


