function alf = stabTT(sys,ddlstab,HH)

backddl = length(ddlstab(1:end-2)) / (2*HH+1);
nbddl = get_nbddlT(sys, backddl+1);
Nech = sys.nech;
TT = 2.*pi/ddlstab(end);

if ddlstab(end) < 0.01
    errordlg('La frquence tudie tend vers zro : risque de cas singulier o la priode est infinie','Cas particulier point fixe','on');
end

tt=linspace(0,TT,Nech);
dt=tt(2)-tt(1);

Yn = eye(nbddl);

for ii=1:length(tt)
    ti = tt(ii);
    Yn = rungekutta4(sys,Yn,dt,ti,ddlstab,HH);
end

alf = eig(Yn);
end



function Ynp1 = rungekutta4(sys,Yn,dt,ti,ddlstab,HH)

k1=JT(sys,recomposition_Fourier(ti,ddlstab,HH))*Yn;
k2=JT(sys,recomposition_Fourier(ti+dt/2,ddlstab,HH))*(Yn+dt/2*k1);
k3=JT(sys,recomposition_Fourier(ti+dt/2,ddlstab,HH))*(Yn+dt/2*k2);
k4=JT(sys,recomposition_Fourier(ti+dt,ddlstab,HH))*(Yn+dt*k3);

Ynp1 = Yn+dt/6*(k1+2*k2+2*k3+k4);

end



function UUfinal = recomposition_Fourier(ti,ddlstab,HH) 

backddl = length(ddlstab(1:end-2)) / (2*HH+1);
TT = 2.*pi/ddlstab(end);
UU = ddlstab(1:backddl);

for j=1:HH
        
    UU = UU + ddlstab(backddl*(2*j-1)+1:backddl*2*j)*cos(2*pi*j*ti/TT)+...
              ddlstab(2*j*backddl+1:(2*j+1)*backddl)*sin(2*pi*j*ti/TT);
end

UUfinal = [UU ddlstab(end-1)];

end