% La correction NR se fait sur le probleme Ra.
% Mais le seuil est compare a la norme du probleme total
% Le S est calcule pour chaque iteration 

function [U] = correction(sys, seuil, itemax, U )

Usave = U;

nbites = 0;

R = get_R(sys,U);

RU = R(sys.idxRU);   
normR = norm(R);


disp(['N-R : Avant correction ||R(Uj)||=' num2str(norm(R)) ] );

while (normR > seuil) && (nbites < itemax)
  
  nbites = nbites + 1;

  dRUdU = get_dRdU(sys,U);

  UU = U(sys.idxUU); 
  
  Ut = tangente(sys, dRUdU,UU);
  
  K = [dRUdU ; Ut(sys.idxUU)'];
  
  Kinv = inv(K);

  UU = UU - Kinv * [RU;0];
 
  P = get_pertvector(sys.SYS) ;
  
  S = get_S(sys,UU) - P(sys.idxUS-1);
  U = [ UU ; S ];
  R = get_R(sys,U);
  normR = norm(R);
  RU = R(sys.idxRU);
  
  disp(['N-R' num2str(nbites) ' : ||R(Uj)||=' num2str(normR) ] );
  
end




if isnan(normR)
  warndlg('La correction a echouee : Les valeurs des inconnues ne sont pas des nombres reels. Retour sur le point valide precedent.','Phase de correction','on');
  U = Usave;
end


if nbites == itemax
  warndlg('La correction a echouee : Nombre maximal d iteration atteint. Retour sur le point valide precedent.','Phase de correction','on');
  U = Usave;
end