function Hand=tracbarU_monocol(H,Neq,U,udisp,fig)

col1=[0 0.3 0.6];

% Column vector test
% ==================

if size(udisp,2)>size(udisp,1)
  udisp=udisp';
end

if size(U,2)>size(U,1)
  U=U';
end
if size(U,2)>1
  U=U(:,1);
  disp('tracbarU: U should be a column vector')
end

% Plotting the bargraph
% =====================

if floor(fig)==fig
  figure(fig)
  clf
  hold on
else
  axes(fig)
  hold on
end

% Utrac: vector to be displayed
% =============================

Utrac=[];

% Static component
% ----------------

I0=udisp;
Utrac=U(I0);

% Amplitude computations
% ----------------------

Iinit=1:2:(2*H-1);
Iinit=Iinit*Neq;
II=[];
for ii=1:length(udisp)
  II=[II udisp(ii)+Iinit];
end
II=sort(II);
II=II';

Utrac=[Utrac ; sqrt(U(II).^2+U(II+Neq).^2)];

% Labels
% ======

Ndisp=length(udisp);

dH=ceil(H/10);
Htick=0:dH:H;

dX=Ndisp*dH;
Xtick=1:dX:(H+1)*Ndisp;
Hsize=length(Xtick);

Xtickstr=cell(1,Hsize);
Xtickstr{1}='H0';
for ii=2:Hsize
  Xtickstr{ii}=['H',num2str(Htick(ii))];
end


Hand=bar(Utrac);
set(Hand,'Facecolor',col1)
set(gca,'Xtick',Xtick,'XtickLabel',Xtickstr)
ylabel('Harmonics amplitude')
box on